<html>
   <head>
      <meta http-equiv="pragma"        content="no-cache">
      <meta http-equiv="content-type"  content="text/html; charset=utf-8">
      <title>%value $host% - Report Package Dependencies</title>
      %invoke wia.pub.pkgdepend.ui.util:getStyleMetadata%
      <link rel="stylesheet" type="text/css" href="%value WmRoot/cssFilename%">
      <link rel="stylesheet" type="text/css" href="/WiaRoot/css/wrightia.css">
      <link rel="stylesheet" type="text/css" href="css/package.css">
      <script type="text/javascript" src="/WiaRoot/scripts/wia4dsp.js"></script>
      <script type="text/javascript" src="/WiaRoot/scripts/wia4dom.js"></script>
      %end invoke%
      <script type="text/javascript">
         function updateDependencies() {
            var xResult    = false;
            var xSelectors = getElementsByName("input", "setDep");

            if (xSelectors)
               for(var xIdx = 0; xIdx < xSelectors.length; xIdx++)
                  {
                  var xId           = xSelectors[xIdx].value;
                  var xAllow        = document.getElementById("d"  + xId);

                  if (xSelectors[xIdx].checked)
                     {
                     var xTargetPkg = document.getElementById("tp" + xId);
                     var xAllowPkg  = document.getElementById("ap" + xId);
                     var xAllowVer  = document.getElementById("av" + xId);

                     xAllow.value   = xTargetPkg.value
                                    + "=\""
                                    + xAllowPkg.value + ";" + xAllowVer.value + "\""
                                    ;

                     xResult        = true;
                     }
                  else
                     xAllow.value   = "";
                  }

            if (!xResult)
               alert("No dependencies have been set for update.");

            return xResult;
            }

            function flip(id) {
               var xObj = document.getElementById(id);

               if (xObj.style.display == "block")
                  xObj.style.display = "none";
               else
                  xObj.style.display = "block";

               return true;
            }

            function expandAll() {
               setAll(true);
               return true;
            }

            function collapseAll() {
               setAll(false);
               return true;
            }

            function setAll(show) {
               var xSelectors = getElementsByName("div", "reportDetail");
               if (xSelectors)
                  for(var xIdx = 0; xIdx < xSelectors.length; xIdx++)
                     if (show == true)
                        xSelectors[xIdx].style.display = "block";
                     else
                        xSelectors[xIdx].style.display = "none";
            }

            function toggleReportSummary() {
               var xToggler         = document.getElementById("report-summary-toggler");
               var xReportSummary   = document.getElementById("report-summary");
               if (xToggler && xReportSummary)
                  {
                  if (xToggler.innerHTML == "Show Report Summary")
                     {
                     xReportSummary.style.display  = "block";
                     xToggler.innerHTML            = "Hide Report Summary";
                     }
                  else
                     {
                     xReportSummary.style.display  = "none";
                     xToggler.innerHTML            = "Show Report Summary";
                     }
                  }
            }

            function refreshReport() {
               document.frmRefresh.submit();
               return true;
            }

            function goBack() {
               document.frmGoBack.submit();
               return true;
            }

      </script>
      <style>
         .description {
            font-weight: bold;
            padding-top: .5em;
            padding-bottom: .5em;
            padding-right: 25px;
            text-align: left;
         }

         tr.bottomSpacer {
            height: .3em;
            }

         td.report {
            padding: 0;
            }

         div.reportHeader {
            margin: 5px 0;
            display: block;
            clear: both;
            min-width: 400px;
            height: 1.3em;
            padding-left: .5em;
            padding-right: .5em;
            cursor: pointer;
            }

         div.reportHeader:hover {
            background-color: #553;
            }

         div.reportHeader div.packageId {
            float: left;
            }

         div.reportHeader div.packageId .version, div.reportHeader div.packageIsAdapter {
            color: #eee8aa;
            }

         div.reportHeader div.packageState, div.reportHeader div.packageIsAdapter {
            float: right;
            width: 40px;
            text-align: right;
            padding-right: 3px;
            }

         div.reportDetail {
            clear: both;
            padding: .5em 0 .5em 25px;
            margin: -5px 0 0;
            display: none;
            }

         td.versionId {
            width: 80px;
            }

         input.versionId {
            font-size: .9em;
            }

         input.versionId, td.versionId, td.packageIsAdapter {
            text-align: right;
            }

         td.description, td.packageName {
            width: 80%;
            }

         td.packageIsAdapter {
            width: 3em;
            font-weight: bold;
            }

         td.undefNodeCaller span {
            color:red;
            }

         td.undefNodeTitle, td.circRefTitle, td.usedByTitle {
            font-weight: bold;
            padding-top: .5em;
            }

         td.undefNodeCaller, td.circRefStack, td.usedByPackageName {
            padding-left: 2em;
            }

         td.dependCheck {
            text-align: center;
            padding: 0;
            width: 25px;
            }

         table#report-summary {
            display: none;
            margin-top: 1em;
            margin-bottom: 1em;
            }
         table#report-summary td.undefinedNode{
            padding-left: 1em;
            padding-right: 1em;
            }
         table#report-summary td.counterLabel {
            width: 33em;
            }
         table#report-summary td.packageCount {
            padding-left: 2em;
            padding-right: 1em;
            font-weight: bold;
            }
      </style>
<!--[if IE]>
      <style>
         div.reportDetail, div.reportHeader {
            width:100%;
         }
      </style>
<![endif]-->
   </head>

   <body>

      <table class="pageHeading">
         <tr>
            %invoke wia.pub.pkgdepend.ui.about:getMetadata%
               <td class="menusection-DependencyAnalysis" colspan="2">%value packageLongName%, %value packageVersion% &gt; Analyzer &gt; Report</td>
            %end invoke%
         </tr>
         <tr>
            <td>
               <ul>
                  <li><a href="./">Go Home</a></li>
                  <li><a href="AnalyzeDependencies.dsp%ifvar remoteServer%?remoteServer=%value remoteServer encode('url')%%end if%">Back to a clean Analyzer</a></li>
                  <li>
                     <a href="javascript:goBack();">Back to Analyzer</a>
                  </li>
               </ul>
               %invoke wia.pub.pkgdepend.ui.analysis:analysisReport%
                  <form name="frmGoBack" method="post" action="AnalyzeDependencies.dsp">
                     %loop packages%
                        <input type="hidden" name="packages"       value="%value%"/>
                     %end loop%
                     %loop voidedPackages%
                        <input type="hidden" name="voidedPackages" value="%value%"/>
                     %end loop%
                     %ifvar remoteServer%             <input type="hidden" name="remoteServer"             value="%value remoteServer encode('url')%"/>%end if%
                     %ifvar enrich4ui%                <input type="hidden" name="enrich4ui"                value="%value enrich4ui%"                 />%end if%
                     %ifvar isTopLevelPackagesOnly%   <input type="hidden" name="isTopLevelPackagesOnly"   value="%value isTopLevelPackagesOnly%"    />%end if%
                     %ifvar isConsiderRuntimeData%    <input type="hidden" name="isConsiderRuntimeData"    value="%value isConsiderRuntimeData%"     />%end if%
                     %ifvar filter%                   <input type="hidden" name="filter"                   value="%value filter%"                    />%end if%
                     %ifvar reportExcessDeclarations% <input type="hidden" name="reportExcessDeclarations" value="%value reportExcessDeclarations%"  />%end if%
                  </form>
               %end invoke%
            <td>
         </tr>
      </table>

      <table width="100%"> <!-- this table is being used only to set a left identation to the child tables -->
         %ifvar execute equals('save')%
            %invoke wia.pub.pkgdepend.ui.analysis:saveChanges%
            %onerror%
               <tr>
                  <td class="message" colspan="2">
                     An error occurred trying to build the report data.
                     Check by executing the '%value errorService%' service on a browser.
                     The error details are as follows: <br><br>
                     %value errorMessage%
                  </td>
               </tr>
            %end invoke%
         %end if%
         <tr>
            <td width="10">&nbsp;</td>
            %invoke wia.pub.pkgdepend.ui.analysis:dependencyReport%
               %ifvar message%
                  <td class="message">%value message encode('xml')%</td>
               %else%
                  %ifvar PackageReports%
                     <td>
                        <a name="options"></a>
                        <ul class="options">
                           <li><a href="javascript:void" onclick="javascript: expandAll();">Expand All</a></li>
                           <li> | </li>
                           <li><a href="javascript:void" onclick="javascript: collapseAll();">Collapse All</a></li>
                           <li> | </li>
                           <li><a href="#actions" >Go Bottom</a></li>
                           <li> | </li>
                           <li><a id="report-summary-toggler" href="javascript:void" onclick="javascript: toggleReportSummary();">Show Report Summary</a></li>
                        </ul>

                        <table id="report-summary">
                           <tr class="heading">
                              <td colspan="2">Report Summary</td>
                           </tr>
                           %scope ReportSummary%
                              <tr>
                                 <td class="columnHeading" colspan="2">Package Counts</td>
                              </tr>
                              %scope PackageCounts%
                                 <tr>
                                    <td class="rowlabel counterLabel">Total Number of packages:</td>
                                    <td class="evenrow packageCount">%value total%</td>
                                 </tr>
                                 <tr>
                                    <td class="rowlabel">... with Design Dependencies:</td>
                                    <td class="evenrow packageCount">%value withDesignedDependencies%</td>
                                 </tr>
                                 <tr>
                                    <td class="rowlabel">... with Circular Dependencies:</td>
                                    <td class="evenrow packageCount">%value withCircularDependencies%</td>
                                 </tr>
                                 <tr>
                                    <td class="rowlabel">... with Runtime Dependencies:</td>
                                    <td class="evenrow packageCount">%value withRuntimeDependencies%</td>
                                 </tr>
                                 <tr>
                                    <td class="rowlabel">... with references to Undefined Nodes:</td>
                                    <td class="evenrow packageCount">%value withReferencesToUndefinedNodes%</td>
                                 </tr>
                              %end scope%
                              %ifvar UndefinedNodes%
                                 <tr>
                                    <td class="columnHeading" colspan="2">List of Undefined Nodes (%value undefinedNodesCount%)</td>
                                 </tr>
                                 %loop UndefinedNodes%
                                    <tr>
                                       <td class="evenrow-l undefinedNode" colspan="2">%value%</td>
                                    </tr>
                                 %end loop%
                              %end if%
                           %end scope%
                           <tr>
                              <td colspan="2">
                                 <ul class="options">
                                    <li><a href="#options" >Go Top</a></li>
                                 </ul>
                              </td>
                           </tr>
                        </table>

                        <form id="frmRefresh" name="frmRefresh" method="post" action="ReportDependencies.dsp">
                           %loop packages%
                              <input type="hidden" name="packages"       value="%value%"/>
                           %end loop%
                           %loop voidedPackages%
                              <input type="hidden" name="voidedPackages" value="%value%"/>
                           %end loop%
                           %ifvar remoteServer%             <input type="hidden" name="remoteServer"           value="%value remoteServer encode('url')%"/>%end if%
                           %ifvar enrich4ui%                <input type="hidden" name="enrich4ui"              value="%value enrich4ui%"                 />%end if%
                           %ifvar isTopLevelPackagesOnly%   <input type="hidden" name="isTopLevelPackagesOnly" value="%value isTopLevelPackagesOnly%"    />%end if%
                           %ifvar isConsiderRuntimeData%    <input type="hidden" name="isConsiderRuntimeData"  value="%value isConsiderRuntimeData%"     />%end if%
                           %ifvar filter%                   <input type="hidden" name="filter"                 value="%value filter%"                    />%end if%
                           %ifvar reportExcessDeclarations% <input type="hidden" name="reportExcessDeclarations" value="%value reportExcessDeclarations%"/>%end if%
                        </form>

                        <form id="frmMain" name="frmMain" method="post" action="ReportDependencies.dsp">
                           %loop packages%
                              <input type="hidden" name="packages" value="%value%"/>
                           %end loop%
                           <table name="packageList">
                              %ifvar remoteServer%
                                 <thead>
                                    <tr>
                                       <td class="evenrow">
                                          %ifvar remoteServer%
                                             <table width="100%">
                                                <tr>
                                                   <td class="evenrowdata-r">
                                                      Run on server:
                                                   </td>
                                                   <td class="evenrowdata-l">
                                                      %value remoteServer%
                                                   </td>
                                                </tr>
                                             </table>
                                          %endif%
                                       </td>
                                    </tr>
                                 </thead>
                              %endif%
                              <tbody>
                                 <tr>
                                    <td class="report">
                                       %loop PackageReports%
                                          <a name="a_%value name%"></a>
                                          <div class="columnHeading reportHeader" onclick="javascript: flip('%value name%')">
                                             <div class="packageId">%value name% <span class="version">v%value version%</span></div>
                                             %comment%
                                                E = had Error Message
                                                D = has Design-time dependencies
                                                R = has Runtime dependencies
                                                U = has undefined nodes
                                                C = has circular references
                                                X = has useless declarations
                                             %end comment%
                                             <div class="packageState">%ifvar message%E%endif%%ifvar hasDesignedDependencies equals('true')%D%endif%%ifvar hasRuntimeDependencies equals('true')%R%endif%%ifvar UndefinedReferences%U%endif%%ifvar CircularReferences%C%endif%%ifvar hasUselessDeclarations equals('true')%X%endif%</div>
                                             %comment%
                                                A = is dependent of an Adapter Package
                                             %end comment%
                                             <div class="packageIsAdapter">%ifvar isAdapterDependent equals('true')%A%else%&nbsp;%endif%</div>
                                          </div>
                                          <div name="reportDetail" class="reportDetail oddrow" id="%value name%">
                                             <table width="100%">
                                             %ifvar description%
                                                <tr>
                                                   <td class="description" colspan="4">%value description%</td>
                                                </tr>
                                             %end if%
                                             %loop Dependencies%
                                                <tr>
                                                   <td class="packageName">%ifvar isEffective equals('true')%%ifvar classification equals('design')%(D)%else%%ifvar classification equals('runtime')%(R)%endif%%endif%%else%(X)%endif%
                                                      %ifvar /isTopLevelPackagesOnly equals('true')%
                                                         %value packageName%
                                                      %else%
                                                         %ifvar isSystem equals('true')%
                                                            %value packageName%
                                                         %else%
                                                            <a href="#a_%value packageName%" onclick="javascript: collapseAll(); flip('%value packageName%'); true;">%value packageName%</a>
                                                         %endif%
                                                      %endif%
                                                   </td>
                                                   <td class="packageIsAdapter">%ifvar isAdapter equals('true')%A%else%&nbsp;%endif%</td>
                                                   %ifvar classification equals('declared')%
                                                      <td class="versionId">%value version%</td>
                                                      <td class="dependCheck">&nbsp;</td>
                                                   %else%
                                                      <td class="versionId">
                                                         <input type="hidden"    id="tp%value uniqueName%" value="%value targetPackageName%"/>
                                                         <input type="hidden"    id="ap%value uniqueName%" value="%value packageName%"/>
                                                         <input type="text"      id="av%value uniqueName%" value="%value version%" size="11" class="versionId" %ifvar isDeclarable equals('true')%%else%disabled="true"%end if% />
                                                      </td>
                                                      <td class="dependCheck">
                                                         <input type="checkbox"                           name="setDep"     value="%value uniqueName%" %ifvar isDeclarable equals('true')%%else%disabled="true"%end if% />
                                                         <input type="hidden"    id="d%value uniqueName%" name="dependency" value="" />
                                                      </td>
                                                   %endif%
                                                </tr>
                                             %end loop%
                                             %ifvar listOfReferers%
                                                <tr><td class="usedByTitle" colspan="4">Referenced by these packages</td></tr>
                                                %loop listOfReferers%
                                                   <tr><td class="usedByPackageName" colspan="4"><a href="#a_%value%" onclick="javascript: collapseAll(); flip('%value%'); true;">%value%</a></td></tr>
                                                %end loop%
                                             %end if%
                                             %ifvar CircularReferences%
                                                <tr><td colspan="4" class="circRefTitle">Circular References</td></tr>
                                                %loop CircularReferences/ByDeclaration%
                                                   <tr><td colspan="4">(CD) %value packageName%</td></tr>
                                                   %loop PackageStack%
                                                      <tr>
                                                         <td colspan="4" class="circRefStack">-&nbsp;%value packageName%/%value version%</td>
                                                      </tr>
                                                   %end loop%
                                                %end loop%
                                                %loop CircularReferences/ByReference%
                                                   <tr><td colspan="4">(CR%ifvar isRuntime equals('true')%R%else%D%end if%) %value packageName%</td></tr>
                                                   %loop ReferenceStack%
                                                      <tr>
                                                         <td colspan="4" class="circRefStack">-&nbsp;%value packageName%/%value nodeName%</td>
                                                      </tr>
                                                   %end loop%
                                                %end loop%
                                             %end if%
                                             %ifvar UndefinedReferences%
                                                <tr><td colspan="4" class="undefNodeTitle">References to undefined nodes</td></tr>
                                                %loop UndefinedReferences%
                                                   <tr>
                                                      <td colspan="4" class="undefNodeName">(U) %value Undefined/nodeName%</td>
                                                   </tr>
                                                   <tr>
                                                      <td colspan="4" class="undefNodeCaller"><span>referenced by:</span> %value Caller/nodeName%</td>
                                                   </tr>
                                                %end loop%
                                             %end if%
                                             </table>
                                          </div>
                                       %end loop%
                                    </td>
                                 </tr>
                              </tbody>
                              <tfoot>
                                 <tr>
                                    <td class="action" colspan="3">
                                       <a name="actions"></a>
                                       <input type="submit" name="cmdSave"              value="Save Changes"   onclick="return updateDependencies();" />
                                       <input type="hidden" name="execute" id="execute" value="save" />
                                       <input type="button" name="cmdRefresh"           value="Refresh Report" onclick="return refreshReport();" />
                                    </td>
                                 </tr>
                              </tfoot>
                           </table>
                        </form>
                        <ul class="options">
                           <li><a href="#options" >Go Top</a></li>
                        </ul>
                     </td>
                  %else%
                     <td class="message">No report was generated.</td>
                  %end if%
               %end if%
            %onerror%
               <tr>
                  <td class="message" colspan="2">%value errorMessage  encode('xml')%</td>
               </tr>
            %end invoke%
         </tr>
      </table>
   </body>
</html>
